
/*
 * Name: Bhaskar S
 * 
 * Date: 03/07/2009 
 */

package com.polarsparc.restlet.example.one;

import org.restlet.*;
import org.restlet.data.*;
import org.restlet.resource.*;

// Resource represents an abstract web entity that can be identified
// with a URL. A Resource also manages data representations
public class DvdResource extends Resource {
	private static DvdDAO _DAO;
	
	static {
		try {
			_DAO = new DvdDAO();
			_DAO.init();
		}
		catch (Exception ex) {
			ex.printStackTrace(System.err);
			System.exit(1);
		}
	}
	
	public DvdResource(Context context, Request request, Response response) {  
		super(context, request, response);  

		// Variant is an abstraction of data representation for a Resource
		// In this case we are only supporting XML data representation
		getVariants().add(new Variant(MediaType.TEXT_XML));  
	}
	
	@Override
	// Handle the GET - Need to override to implement the state behind
	// our DVD resource
	public Representation represent(Variant variant)
		throws ResourceException {
		if (MediaType.TEXT_XML.equals(variant.getMediaType())) {
			String movie = (String) getRequest().getAttributes().get("movie");
			
			System.out.println("-> Requested DVD Movie: " + movie);
			
			String info = null;
			
			try {
				info = _DAO.find(movie);
			}
			catch (Exception ex) {
				ex.printStackTrace(System.err);
			}
			
			if (info != null) {
				return new StringRepresentation(info, MediaType.TEXT_XML);
			}
		}
		return null;
	}
}